local L = Capitalist.Locals

function Capitalist:CreateReagentUI()
	self:DebugEntry("CreateReagentUI")

	self.reagentUIButton = CreateFrame("button", nil, AuctionFrameBrowse)
	local t = self.reagentUIButton
	t:SetPoint("LEFT", self.auctionUIButton, "RIGHT", 0, 0)
	t:SetHeight(30)
	t:SetWidth(30)
	t:SetScript("OnClick", function() Capitalist:ToggleReagentUI() end)
	t:Show()
	
	t.texture = t:CreateTexture()
	t.texture:SetAllPoints()
	t.texture:SetTexture("Interface\\Icons\\inv_enchant_abysscrystal")
	t.texture:SetDrawLayer("BACKGROUND")
	
	t.border = t:CreateTexture()
	t.border:SetAllPoints()
	t.border:SetTexture("Interface\\Buttons\\ButtonHilight-Square")
	t.border:SetBlendMode("ADD")
	t.border:SetDrawLayer("BORDER")
	t.border:Hide()
	t:SetScript("OnEnter", function(self) self.border:Show() end)
	t:SetScript("OnLeave", function(self) if (not Capitalist.reagentUI:IsVisible()) then self.border:Hide() end end)
	
	
	
	
	self.reagentUI = CreateFrame("frame", nil, AuctionFrameBrowse)
	t = self.reagentUI
	t:SetPoint("TOPLEFT", AuctionFrame, "TOPLEFT", 16, -101)
	t:SetPoint("BOTTOMRIGHT", AuctionFrame, "BOTTOMRIGHT", -7, 37)
	t:SetFrameStrata("HIGH")
	t:EnableMouse(true)
	t:Hide()
	
	t.background = t:CreateTexture(nil, "BACKGROUND")
	t.background:SetAllPoints()
	t.background:SetTexture(0,0,0)
	
	
	t.items = {}
	for i = 1, 5 do
		t.items[i] = CreateFrame("frame", nil, t)
		local item = t.items[i]
		item:SetWidth(500)
		item:SetHeight(52)
		item:SetPoint("TOPLEFT", t, "TOPLEFT", 0, 32-52*i)
		
		item.histogram = CreateFrame("frame", nil, item)
		local hist = item.histogram
		hist:SetWidth(242)
		hist:SetHeight(52)
		hist:SetPoint("TOPLEFT", 4, 0)
		
		hist.background = hist:CreateTexture(nil, "BACKGROUND")
		hist.background:SetAllPoints()
		hist.background:SetTexture(0.1, 0.1, 0.1)
		
		hist.segments = {}
		hist.segmentBackgrounds = {}
		for j = 1, 60 do
			hist.segments[j] = hist:CreateTexture(nil, "OVERLAY")
			local s = hist.segments[j]
			s:SetWidth(4)
			s:SetHeight(10)
			s:SetPoint("BOTTOMLEFT", 4*(j-1)+1, 1)
			s:SetTexture(j/60, 1-(j/60), 0)
			
			hist.segmentBackgrounds[j] = hist:CreateTexture(nil, "BORDER")
			s = hist.segmentBackgrounds[j]
			s:SetWidth(4)
			s:SetHeight(50)
			s:SetPoint("BOTTOMLEFT", 4*(j-1)+1, 1)
			s:SetTexture(0,0,0)
		end
		
		
		item.name = item:CreateFontString(nil, nil, "GameFontNormal")
		item.name:SetWidth(175)
		item.name:SetPoint("TOPLEFT", 250, -10)
		item.name:SetText("")
		item.name:SetJustifyH("LEFT")
		
		item.scanButton = CreateFrame("button", nil, item, "UIPanelButtonTemplate")
		item.scanButton:SetWidth(60)
		item.scanButton:SetHeight(20)
		item.scanButton:SetText("scan")
		item.scanButton:SetPoint("TOPLEFT", item.name, "BOTTOMLEFT")
		item.scanButton:SetScript("OnClick", function() Capitalist:ScanReagent(i) end)
		
		item.info1 = item:CreateFontString(nil, nil, "GameFontNormal")
		item.info1:SetWidth(315)
		item.info1:SetPoint("TOPLEFT", 425, 0)
		item.info1:SetText("")
		item.info1:SetJustifyH("LEFT")
		
		item.info2 = item:CreateFontString(nil, nil, "GameFontNormal")
		item.info2:SetWidth(315)
		item.info2:SetPoint("TOPLEFT", item.info1, "BOTTOMLEFT")
		item.info2:SetText("")
		item.info2:SetJustifyH("LEFT")
		
		item.info3 = item:CreateFontString(nil, nil, "GameFontNormal")
		item.info3:SetWidth(315)
		item.info3:SetPoint("TOPLEFT", item.info2, "BOTTOMLEFT")
		item.info3:SetText("")
		item.info3:SetJustifyH("LEFT")
		
		item.prevStackButton = CreateFrame("button", nil, item, "UIPanelButtonTemplate")
		item.prevStackButton:SetWidth(15)
		item.prevStackButton:SetHeight(20)
		item.prevStackButton:SetText("<")
		item.prevStackButton:SetPoint("TOPLEFT", 730, 0)
		item.prevStackButton:SetScript("OnClick", function()
												local name = Capitalist.reagentUI.items[i].name:GetText()
												local currentStack = Capitalist.reagentCurrentStack[name]
												local count = Capitalist.reagentScanData[name][currentStack].count
												local smallerStack
												local index
												
												for i = currentStack, 1, -1 do
													local size = Capitalist.reagentScanData[name][i].count
													if (not smallerStack and size < count) then
														smallerStack = size
													end
													if (size == smallerStack) then
														index = i
													end
												end
												
												if (index) then
													Capitalist.reagentCurrentStack[name] = index
													Capitalist:UpdateHistogram(i)
													Capitalist:SearchStack(name)
												end
											end)
		
		item.prevButton = CreateFrame("button", nil, item, "UIPanelButtonTemplate")
		item.prevButton:SetWidth(25)
		item.prevButton:SetHeight(20)
		item.prevButton:SetText("<<")
		item.prevButton:SetPoint("LEFT", item.prevStackButton, "RIGHT")
		item.prevButton:SetScript("OnClick", function()
												local name = Capitalist.reagentUI.items[i].name:GetText()
												Capitalist.reagentCurrentStack[name] = Capitalist.reagentCurrentStack[name] - 1
												Capitalist:UpdateHistogram(i)
												Capitalist:SearchStack(name)
											end)

		item.nextButton = CreateFrame("button", nil, item, "UIPanelButtonTemplate")
		item.nextButton:SetWidth(25)
		item.nextButton:SetHeight(20)
		item.nextButton:SetText(">>")
		item.nextButton:SetPoint("LEFT", item.prevButton, "RIGHT")
		item.nextButton:SetScript("OnClick", function()
												local name = Capitalist.reagentUI.items[i].name:GetText()
												Capitalist.reagentCurrentStack[name] = Capitalist.reagentCurrentStack[name] + 1
												Capitalist:UpdateHistogram(i)
												Capitalist:SearchStack(name)
											end)

		item.nextStackButton = CreateFrame("button", nil, item, "UIPanelButtonTemplate")
		item.nextStackButton:SetWidth(15)
		item.nextStackButton:SetHeight(20)
		item.nextStackButton:SetText(">")
		item.nextStackButton:SetPoint("LEFT", item.nextButton, "RIGHT")
		item.nextStackButton:SetScript("OnClick", function()
												local name = Capitalist.reagentUI.items[i].name:GetText()
												local currentStack = Capitalist.reagentCurrentStack[name]
												local count = Capitalist.reagentScanData[name][currentStack].count
												
												for j = currentStack, #Capitalist.reagentScanData[name] do
													local size = Capitalist.reagentScanData[name][j].count
													if (size > count) then
														Capitalist.reagentCurrentStack[name] = j
														Capitalist:UpdateHistogram(i)
														Capitalist:SearchStack(name)
														return
													end
												end
											end)
											
		item.buyButton = CreateFrame("button", nil, item, "UIPanelButtonTemplate")
		item.buyButton:SetWidth(80)
		item.buyButton:SetHeight(20)
		item.buyButton:SetText("buy stack")
		item.buyButton:SetPoint("TOPLEFT", item.prevStackButton, "BOTTOMLEFT")
		item.buyButton:SetScript("OnEnter", function()
												Capitalist:SearchStack(Capitalist.reagentUI.items[i].name:GetText())
											end)

		item.buyButton:SetScript("OnClick", function()
												Capitalist:BuyStack(Capitalist.reagentUI.items[i].name:GetText())
											end)
	end
	
	t.page = 0
	
	t.prevButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.prevButton:SetWidth(30)
	t.prevButton:SetHeight(20)
	t.prevButton:SetText("<<")
	t.prevButton:SetPoint("TOPLEFT", t.items[5], "BOTTOMLEFT", 250, 0)
	t.prevButton:SetScript("OnClick", function()
										local i = Capitalist.reagentUI.page
										if (i > 0) then i = i - 1 end
										Capitalist.reagentUI.page = i
										Capitalist.reagentUI.nextButton:Enable()
										if (i == 0) then
											Capitalist.reagentUI.prevButton:Disable()
										end
										Capitalist:UpdateReagentUI()
									  end)
	t.prevButton:Disable()
	
	t.nextButton = CreateFrame("button", nil, t, "UIPanelButtonTemplate")
	t.nextButton:SetWidth(30)
	t.nextButton:SetHeight(20)
	t.nextButton:SetText(">>")
	t.nextButton:SetPoint("LEFT", t.prevButton, "RIGHT", 10, 0)
	t.nextButton:SetScript("OnClick", function()
									Capitalist.reagentUI.page = Capitalist.reagentUI.page + 1
									Capitalist.reagentUI.prevButton:Enable()
									Capitalist:UpdateReagentUI()
								  end)

	self:DebugExit("CreateReagentUI")
end

function Capitalist:ToggleReagentUI()
	self:DebugEntry("ToggleReagentUI")

	if (self.auctionUI:IsVisible()) then
		self:ToggleAuctionUI()
	end

	if (self.reagentUI:IsVisible()) then
		self.reagentUI:Hide()
		self.reagentUIButton.border:Hide()
		
		BrowseQualitySort:Show()
		BrowseLevelSort:Show()
		BrowseDurationSort:Show()
		BrowseHighBidderSort:Show()
		BrowseCurrentBidSort:Show()
	else
		self.reagentUI:Show()
		self.reagentUIButton.border:Show()
		
		BrowseQualitySort:Hide()
		BrowseLevelSort:Hide()
		BrowseDurationSort:Hide()
		BrowseHighBidderSort:Hide()
		BrowseCurrentBidSort:Hide()
	end

	self:DebugExit("ToggleReagentUI")
end

function Capitalist:ScanReagent(index)
	self:DebugEntry("ScanReagent")

	local name = self.reagentUI.items[index].name:GetText()
	
	if (self.updateHandler:IsVisible()) then
		self:Print("Action in progress!")
	else
		self.mode = name
		self.updateHandler:Show()
		
		QueryAuctionItems(name)
		self.page = 0
		
		self.reagentScanData[name] = {}
		self.reagentCurrentStack[name] = 1
		
		for i = 1, 60 do
			self.reagentUI.items[index].histogram.segments[i]:SetTexture(i/60, 1-(i/60), 0)
		end
	end

	self:DebugExit("ScanReagent")
end

function Capitalist:OnUpdateReagentScanning()
	self:DebugEntry("OnUpdateReagentScanning")
	if (CanSendAuctionQuery()) then
		self.page = self.page + 1
		self:ScanReagents()
	end
	self:DebugExit("OnUpdateReagentScanning")
end

function Capitalist:ScanReagents()
	self:DebugEntry("ScanReagents")

	QueryAuctionItems(self.mode,nil,nil,0,0,0,self.page,0,0,nil)
	
	for i = 1, 50 do
		local name, _, count, _, _, _, _, _, buyoutPrice, _, _, _, _  = GetAuctionItemInfo("list", i)
	
		if (name == nil) then
			self:ReagentScanFinished()
			return
		end

		if (name == self.mode and buyoutPrice > 0 and buyoutPrice < self.db.profile.reagents[name].price * 10000 * count * 4) then
			table.insert(self.reagentScanData[name], {count = count, price = buyoutPrice / count, order = i + (self.page - 1) * 50})
		end
	end
	
	for i = 1, 5 do
		if (self.reagentUI.items[i].name:GetText() == self.mode) then
			local numBatchAuctions, totalAuctions = GetNumAuctionItems("list");
			local progress = math.floor(60 * self.page * 50 / totalAuctions)
			
			for j = 1, progress do
				self.reagentUI.items[i].histogram.segments[j]:SetHeight(50)
			end
			
			for j = progress + 1, 60 do
				self.reagentUI.items[i].histogram.segments[j]:SetHeight(0.01)
			end
		end
	end

	self:DebugExit("ScanReagents")
end

function Capitalist:ReagentScanFinished()
	self:DebugEntry("ReagentScanFinished")

	self.updateHandler:Hide()

	table.sort(self.reagentScanData[self.mode], function(a, b)
													if (a.price == b.price) then
														return a.count > b.count
													else
														return a.price < b.price
													end
												end)
	
	for i = 1, 5 do
		if (self.reagentUI.items[i].name:GetText() == self.mode) then
			self:UpdateHistogram(i)
		end
	end

	self:DebugExit("ReagentScanFinished")
end

function Capitalist:UpdateReagentUI()
	self:DebugEntry("UpdateReagentUI")

	if (not self.reagentScanData) then
		self.reagentScanData = {}
		self.reagentCurrentStack = {}
	end
	
	local t = self.reagentUI
	
	local reagentList = {}
	for reagent, data in pairs(self.db.profile.reagents) do
		if (data.isUsed and not data.isFiltered) then
			table.insert(reagentList, reagent)
		end
	end
	
	table.sort(reagentList, function(a, b) return self.db.profile.reagents[a].itemId < self.db.profile.reagents[b].itemId end)
	
	for i = 1, 5 do
		local index = i + self.reagentUI.page * 5
		if (index > #reagentList) then
			t.items[i]:Hide()
			t.nextButton:Disable()
		else
			t.items[i]:Show()
			t.items[i].name:SetText(reagentList[index])

			self:UpdateHistogram(i)
		end
	end

	self:DebugExit("UpdateReagentUI")
end

function Capitalist:CreateReagentStorageString(reagent)
	self:DebugEntry("CreateReagentStorageString")

	local numInInv = self.db.profile.storage[GetCVar("realmName")][UnitName("player")].inventory[reagent]
	local numInBank = self.db.profile.storage[GetCVar("realmName")][UnitName("player")].bank[reagent]
	
	local numOtherChars = 0
	for player, data in pairs(self.db.profile.storage[GetCVar("realmName")]) do
		if (player ~= UnitName("player")) then
			local t = data.inventory[reagent]
			if (t) then numOtherChars = numOtherChars + t end
			t = data.bank[reagent]
			if (t) then numOtherChars = numOtherChars + t end
		end
	end
	
	local sum = 0
	
	local str = ""
	if (numInInv) then
		str = "Inv: "..numInInv
		sum = sum + numInInv
	end
	if (numInBank) then
		if (str ~= "") then str = str..", " end
		str = str.."Bank: "..numInBank
		sum = sum + numInBank
	end
	if (numOtherChars > 0) then
		if (str ~= "") then str = str..", " end
		str = str.."Other: "..numOtherChars
		sum = sum + numOtherChars
	end
	
	local missing = self.requiredReagents[reagent]
	if (missing) then
		missing = missing - sum
		if (missing > 0) then
			if (str ~= "") then str = str..", " end
			str = str.."Missing: "..missing
		end
	end
	
	return self:DebugExit("CreateReagentStorageString", str)
end

function Capitalist:UpdateHistogram(index)
	self:DebugEntry("UpdateHistogram")
	
	local item = self.reagentUI.items[index]
	local reagent = item.name:GetText()
	local data = self.reagentScanData[reagent]
	if (not data) then
		for i = 1, 60 do
			item.histogram.segments[i]:SetHeight(10)
			item.histogram.segments[i]:SetTexture(i/60, 1-(i/60), 0)
			item.histogram.segmentBackgrounds[i]:SetTexture(0, 0, 0)
		end
		item.info1:SetText(self:CreateReagentStorageString(reagent))
		item.info2:SetText("")
		item.info3:SetText("")
		
		item.prevStackButton:Hide()
		item.prevButton:Hide()
		item.nextButton:Hide()
		item.nextStackButton:Hide()
		item.buyButton:Hide()

		return self:DebugExit("UpdateHistogram")
	elseif (#data == 0) then
		for i = 1, 60 do
			item.histogram.segments[i]:SetHeight(0.01)
		end

		local storageString = self:CreateReagentStorageString(reagent)
		if (storageString ~= "") then
			item.info1:SetText("AH: -, "..storageString)
		else
			item.info1:SetText("AH: -")
		end
		item.info2:SetText("")
		item.info3:SetText("")
		
		item.prevStackButton:Hide()
		item.prevButton:Hide()
		item.nextButton:Hide()
		item.nextStackButton:Hide()
		item.buyButton:Hide()

		return self:DebugExit("UpdateHistogram")
	end
	
	local minPrice = data[1].price
	local maxPrice = data[#data].price
	local myPrice = self.db.profile.reagents[reagent].price * 10000

	-- save for text display
	local realMinPrice = minPrice
	local realMaxPrice = maxPrice
	
	if (minPrice > myPrice) then minPrice = myPrice end
	if (maxPrice < myPrice) then maxPrice = myPrice end
	
	local width = (maxPrice - minPrice) / (60 - 1)
	local segments = {}
	for i = 1, 60 do segments[i] = 0 end
	
	local maxHeight = 0
	
	for i = 1, #data do
		local segment = math.floor((data[i].price - minPrice) / width) + 1
		segments[segment] = segments[segment] + data[i].count
		if (segments[segment] > maxHeight) then
			maxHeight = segments[segment]
		end
	end
	
	local myPriceSegment = math.floor((myPrice - minPrice) / width) + 1
	
	for i = 1, 60 do
		local segment = item.histogram.segments[i]
		local background = item.histogram.segmentBackgrounds[i]
	
		segment:SetHeight((segments[i] * 50 / maxHeight) + 0.01) -- add 0.01 to prevent SetHeight(0), which doesnt work
		
		if (i == myPriceSegment) then
			background:SetTexture(0.1, 0.1, 0.1)
			segment:SetTexture(1, 1, 0)
		else
			background:SetTexture(0, 0, 0)
			if (i < myPriceSegment) then
				segment:SetTexture(0, 1, 0)
			else
				segment:SetTexture(1, 0, 0)
			end
		end
	end
	
	-- update texts
	
	local numItems = 0
	for i = 1, #data do numItems = numItems + data[i].count end
	
	local storageString = self:CreateReagentStorageString(reagent)
	if (storageString ~= "") then
		item.info1:SetText("AH: "..numItems..", "..storageString)
	else
		item.info1:SetText("AH: "..numItems)
	end

	item.info2:SetText(self:GetMoneyText(realMinPrice, false, 3).." - "..self:GetMoneyText(realMaxPrice, false, 3)..
												" (own price: "..self:GetMoneyText(myPrice, false, 3)..")")

	local currentStack = self.reagentCurrentStack[reagent]
	local currentStackSize = data[currentStack].count
	local currentStackPrice = currentStackSize * data[currentStack].price
	
	item.info3:SetText("stack #"..currentStack..": "..currentStackSize.."x "..self:GetMoneyText(data[currentStack].price, false, 3)..
												" ("	..self:GetMoneyText(currentStackPrice, false, 3)..")")
												
	if (data[currentStack].price < myPrice) then
		item.info3:SetTextColor(0, 1, 0)
	elseif (data[currentStack].price == myPrice) then
		item.info3:SetTextColor(1, 1, 0)	
	else
		item.info3:SetTextColor(1, 0, 0)
	end
	
	-- update buttons
	item.prevStackButton:Show()
	item.prevButton:Show()
	item.nextButton:Show()
	item.nextStackButton:Show()
	item.buyButton:Show()

	item.prevStackButton:Disable()
	item.nextStackButton:Disable()
	
	for i = currentStack - 1, 1, -1 do
		if (data[i].count < currentStackSize) then
			item.prevStackButton:Enable()
		end
	end
	
	for i = currentStack + 1, #data do
		if (data[i].count > currentStackSize) then
			item.nextStackButton:Enable()
		end
	end
		
	if (currentStack == 1) then
		item.prevButton:Disable()
	else
		item.prevButton:Enable()
	end
	
	if (currentStack == #data) then
		item.nextButton:Disable()
	else
		item.nextButton:Enable()
	end
	
	self:SearchStack(reagent)

	self:DebugExit("UpdateHistogram")
end

function Capitalist:BuyStack(reagent)
	self:DebugEntry("BuyStack")

	local index, cost = self:SearchStack(reagent)
	if (index) then
		PlaceAuctionBid("list", index, cost)

		local currentStack = self.reagentCurrentStack[reagent]
		local data = self.reagentScanData[reagent]
		local order = data[currentStack].order
		table.remove(data, currentStack)
		if (currentStack > #data) then currentStack = #data end
		
		for k, v in pairs(data) do
			if (v.order > order) then
				data[k].order = data[k].order - 1
			end
		end
		
		for i = 1, 5 do
			if (self.reagentUI.items[i].name:GetText() == reagent) then
				self:UpdateHistogram(i)
			end
		end
	else
		-- start search for stack only if doing nothing or scanning for another reagent
		if (not self.updateHandler:IsVisible() or (self.mode == "reagentsearching" and self.reagentSearch ~= reagent)) then
			self.reagentSearchedPages = {}
			self.reagentSearch = reagent
			self.mode = "reagentsearching"
			self.updateHandler:Show()
		end
	end

	self:DebugExit("BuyStack")
end

function Capitalist:SearchStack(reagent)
	self:DebugEntry("SearchStack")

	local itemIndex
	for i = 1, 5 do
		self.reagentUI.items[i].buyButton:SetText("search")
		if (self.reagentUI.items[i].name:GetText() == reagent) then
			itemIndex = i
		end
	end
	
	if (not itemIndex) then return end

	local currentStack = self.reagentCurrentStack[reagent]
	local data = self.reagentScanData[reagent]
	
	local stackCount = data[currentStack].count
	local stackPrice = data[currentStack].price
	local stackOrder = data[currentStack].order
	
	-- search the current list for this auction
	for i = 1, GetNumAuctionItems("list") do
		local name, _, count, _, _, _, _, _, buyoutPrice, _, _, _, _  = GetAuctionItemInfo("list", i)
		if (name == reagent and count == stackCount and buyoutPrice / count == stackPrice) then
			self.reagentUI.items[itemIndex].buyButton:SetText("buy stack")
			if (self.mode == "reagentsearching" and self.reagentSearch == reagent) then
				self.updateHandler:Hide()
			end

			self:DebugExit("SearchStack")
			return i, buyoutPrice
		end
	end
	
	-- if not found start the update handler to find it
	if (not self.updateHandler:IsVisible()) then
		self.reagentSearchedPages = {}
		self.reagentSearch = reagent
		self.mode = "reagentsearching"
		self.updateHandler:Show()
		
		local page = math.ceil(stackOrder / 50) - 1
		self.page = page
		QueryAuctionItems(reagent,nil,nil,0,0,0,page,0,0,nil)
	end

	self:DebugExit("SearchStack")
end

function Capitalist:OnUpdateReagentSearching()
	self:DebugEntry("OnUpdateReagentSearching")

	if (CanSendAuctionQuery()) then
		if (not self:SearchStack(self.reagentSearch)) then
			self.reagentSearchedPages[self.page] = true
			
			if (self.page > 0) then
				self.page = self.page - 1
			else
				self.page = #self.reagentSearchedPages + 1
				-- only search further if there are still auctions
				if (GetNumAuctionItems("list") < 50) then
					self.updateHandler:Hide()
				end
			end
			
			QueryAuctionItems(self.reagentSearch,nil,nil,0,0,0,self.page,0,0,nil)
		end
	end

	self:DebugExit("OnUpdateReagentSearching")
end
